import { computed as p, ref as o, watch as U, onMounted as V, onBeforeUnmount as ee, openBlock as r, createElementBlock as v, normalizeStyle as C, createBlock as _, createCommentVNode as d, unref as s, createSlots as te, withCtx as x, renderSlot as f, normalizeProps as X, guardReactiveProps as B, normalizeClass as G, Fragment as ae, renderList as le, toDisplayString as ne } from "vue";
import { u as se, c as oe, t as re, o as ue, e as ie, w as T, X as ce, i as he, v as E, f as ve } from "./index-BbO9Hp9f.js";
import { _ as de } from "./Title-qba88G9l.js";
import { u as fe, U as ye } from "./usePrinter-CGrHmZQx.js";
import { t as ge, u as me } from "./useResponsive-NZB-WLRF.js";
import pe from "./vue-ui-skeleton-BvkcP6ga.js";
import { u as j } from "./useNestedProp-BCRH6JNl.js";
import { _ as ke } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const we = ["id"], be = ["xmlns", "viewBox"], Ce = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-linecap"], _e = ["cx", "cy", "r", "stroke", "stroke-width"], xe = ["x", "y", "font-size", "fill", "font-weight"], Ie = {
  key: 3,
  class: "vue-data-ui-watermark"
}, $e = {
  __name: "vue-ui-wheel",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(D, { expose: R }) {
    const i = D, { vue_ui_wheel: Y } = se(), k = p(() => !!i.dataset && Object.keys(i.dataset).length), w = o(oe()), H = o(null), I = o(0), y = o(null), $ = o(null), F = o(0), e = p({
      get: () => P(),
      set: (t) => t
    });
    function P() {
      const t = j({
        userConfig: i.config,
        defaultConfig: Y
      });
      return t.theme ? {
        ...j({
          userConfig: re.vue_ui_wheel[t.theme] || i.config,
          defaultConfig: t
        })
      } : t;
    }
    U(() => i.config, (t) => {
      e.value = P(), A(), F.value += 1;
    }, { deep: !0 });
    const { isPrinting: z, isImaging: S, generatePdf: O, generateImage: M } = fe({
      elementId: w.value,
      fileName: e.value.style.chart.title.text || "vue-ui-wheel"
    }), l = o({
      size: 360,
      height: 360,
      width: 360
    }), b = o(e.value.style.chart.layout.percentage.fontSize), u = p(() => ({
      radius: Math.min(l.value.width, l.value.height) * 0.9 / 2,
      centerX: l.value.width / 2,
      centerY: l.value.height / 2
    }));
    function N(t, c = 1) {
      return {
        x: u.value.centerX + u.value.radius * Math.cos(29.85 + t * Math.PI / 180) * c,
        y: u.value.centerY + u.value.radius * Math.sin(29.85 + t * Math.PI / 180) * c
      };
    }
    const n = o(e.value.style.chart.animation.use ? 0 : i.dataset.percentage || 0);
    U(() => i.dataset, (t) => {
      e.value.style.chart.animation.use ? L(t.percentage) : n.value = t.percentage || 0;
    }, { deep: !0 });
    const g = o(null);
    V(() => {
      A();
    });
    function A() {
      if (ue(i.dataset) && ie({
        componentName: "VueUiWheel",
        type: "dataset"
      }), L(i.dataset.percentage || 0), e.value.responsive) {
        const t = ge(() => {
          const { width: c, height: a } = me({
            chart: y.value,
            title: e.value.style.chart.title.text ? $.value : null
          });
          l.value.width = c, l.value.height = a, b.value = e.value.style.chart.layout.percentage.fontSize / 360 * Math.min(c, a);
        });
        g.value = new ResizeObserver(t), g.value.observe(y.value.parentNode);
      }
    }
    ee(() => {
      g.value && g.value.disconnect();
    });
    function L(t) {
      let c = e.value.style.chart.animation.speed;
      const a = Math.abs(t - n.value) / (c * 120);
      function h() {
        n.value < t ? n.value = Math.min(n.value + a, t) : n.value > t && (n.value = Math.max(n.value - a, t)), n.value !== t && requestAnimationFrame(h);
      }
      h();
    }
    const W = p(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const h = n.value > a ? e.value.style.chart.layout.wheel.ticks.activeColor : e.value.style.chart.layout.wheel.ticks.inactiveColor, { x: J, y: K } = N(l.value.size / 100 * a), { x: Q, y: Z } = N(l.value.size / 100 * a, 0.9);
        t.push({
          x1: J,
          y1: K,
          x2: Q,
          y2: Z,
          color: e.value.style.chart.layout.wheel.ticks.gradient.show ? T(h, a / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : h
        });
      }
      return t;
    }), m = o(!1);
    function q(t) {
      m.value = t, I.value += 1;
    }
    return R({
      generatePdf: O,
      generateImage: M
    }), (t, c) => (r(), v("div", {
      class: "vue-ui-wheel",
      ref_key: "wheelChart",
      ref: y,
      id: w.value,
      style: C(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.style.chart.title.text ? (r(), v("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: $,
        style: C(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        (r(), _(de, {
          key: `title_${F.value}`,
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : d("", !0),
      e.value.userOptions.show && k.value ? (r(), _(ye, {
        ref_key: "details",
        ref: H,
        key: `user_options_${I.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: s(z),
        isImaging: s(S),
        uid: w.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: m.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: y.value,
        onToggleFullscreen: q,
        onGeneratePdf: s(O),
        onGenerateImage: s(M)
      }, te({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: x(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: x(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: x(({ toggleFullscreen: a, isFullscreen: h }) => [
            f(t.$slots, "optionFullscreen", X(B({ toggleFullscreen: a, isFullscreen: h })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      k.value ? (r(), v("svg", {
        key: 2,
        xmlns: s(ce),
        class: G({ "vue-data-ui-fullscreen--on": m.value, "vue-data-ui-fulscreen--off": !m.value }),
        viewBox: `0 0 ${l.value.width <= 0 ? 10 : l.value.width} ${l.value.height <= 0 ? 10 : l.value.height}`,
        style: C(`max-width:100%;overflow:visible;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        (r(!0), v(ae, null, le(W.value, (a, h) => (r(), v("line", {
          x1: a.x1,
          x2: a.x2,
          y1: a.y1,
          y2: a.y2,
          stroke: a.color,
          "stroke-width": 5 / 360 * Math.min(l.value.width, l.value.height),
          "stroke-linecap": e.value.style.chart.layout.wheel.ticks.rounded ? "round" : "butt",
          class: G({ "vue-ui-tick-animated": e.value.style.chart.animation.use && h <= n.value })
        }, null, 10, Ce))), 256)),
        e.value.style.chart.layout.innerCircle.show ? (r(), v("circle", {
          key: 0,
          cx: u.value.centerX,
          cy: u.value.centerY,
          r: u.value.radius * 0.8 <= 0 ? 1e-4 : u.value.radius * 0.8,
          stroke: e.value.style.chart.layout.innerCircle.stroke,
          "stroke-width": e.value.style.chart.layout.innerCircle.strokeWidth,
          fill: "none"
        }, null, 8, _e)) : d("", !0),
        e.value.style.chart.layout.percentage.show ? (r(), v("text", {
          key: 1,
          x: u.value.centerX,
          y: u.value.centerY + b.value / 3,
          "font-size": b.value,
          fill: e.value.style.chart.layout.wheel.ticks.gradient.show ? s(T)(e.value.style.chart.layout.wheel.ticks.activeColor, n.value / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.wheel.ticks.activeColor,
          "text-anchor": "middle",
          "font-weight": e.value.style.chart.layout.percentage.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabluar-nums" }
        }, ne(s(he)(
          e.value.style.chart.layout.percentage.formatter,
          s(E)(n.value),
          s(ve)({
            v: s(E)(n.value),
            s: "%",
            r: e.value.style.chart.layout.percentage.rounding
          })
        )), 9, xe)) : d("", !0),
        f(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, be)) : d("", !0),
      t.$slots.watermark ? (r(), v("div", Ie, [
        f(t.$slots, "watermark", X(B({ isPrinting: s(z) || s(S) })), void 0, !0)
      ])) : d("", !0),
      k.value ? d("", !0) : (r(), _(pe, {
        key: 4,
        config: {
          type: "wheel",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            wheel: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, we));
  }
}, Le = /* @__PURE__ */ ke($e, [["__scopeId", "data-v-355bd3d3"]]);
export {
  Le as default
};
